// RichEditCtrlEx.cpp : implementation file
//

#include "stdafx.h"
#include "XDbar.h"
#include "RichEditCtrlEx.h"


// CRichEditCtrlEx

IMPLEMENT_DYNAMIC(CRichEditCtrlEx, CRichEditCtrl)

CRichEditCtrlEx::CRichEditCtrlEx()
{

}

CRichEditCtrlEx::~CRichEditCtrlEx()
{
}


BEGIN_MESSAGE_MAP(CRichEditCtrlEx, CRichEditCtrl)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_UNDO, &CRichEditCtrlEx::OnEditUndo)
	ON_COMMAND(ID_EDIT_CUT, &CRichEditCtrlEx::OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, &CRichEditCtrlEx::OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, &CRichEditCtrlEx::OnEditPaste)
	ON_COMMAND(ID_EDIT_CLEAR, &CRichEditCtrlEx::OnEditDelete)
	ON_COMMAND(ID_EDIT_SELECT_ALL, &CRichEditCtrlEx::OnEditSelectAll)
	ON_COMMAND(ID_EDIT_CLEAR_ALL, &CRichEditCtrlEx::OnEditClearAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, &CRichEditCtrlEx::OnUpdateEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, &CRichEditCtrlEx::OnUpdateEditState)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, &CRichEditCtrlEx::OnUpdateEditState)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, &CRichEditCtrlEx::OnUpdateEditState)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, &CRichEditCtrlEx::OnUpdateEditPaste)
END_MESSAGE_MAP()



// CRichEditCtrlEx message handlers


void CRichEditCtrlEx::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu menu;
	VERIFY(menu.LoadMenu(IDR_MAINFRAME));

	CMenu* pPopup = menu.GetSubMenu(1);
	ASSERT(pPopup != NULL);
	CWnd* pWndPopupOwner = this;

	//while (pWndPopupOwner->GetStyle() & WS_CHILD)
	//	pWndPopupOwner = pWndPopupOwner->GetParent();

	pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			AfxGetMainWnd());
	
}// OnContextMenu(CWnd* pWnd, CPoint point)

void CRichEditCtrlEx::OnUpdateEditUndo(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(CanUndo());
}

void CRichEditCtrlEx::OnEditUndo()
{
	Undo();
	EmptyUndoBuffer();
}

void CRichEditCtrlEx::OnUpdateEditPaste(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(CanPaste());

}

void CRichEditCtrlEx::OnEditPaste()
{
	Paste();
}

void CRichEditCtrlEx::OnUpdateEditState(CCmdUI *pCmdUI)
{
	BOOL bEnable = GetEditStatusEnable();
	pCmdUI->Enable(bEnable);
}


void CRichEditCtrlEx::OnEditCut()
{
	Cut();
}


void CRichEditCtrlEx::OnEditCopy()
{
	Copy();
}


void CRichEditCtrlEx::OnEditDelete()
{
	Clear();
}

void CRichEditCtrlEx::OnEditSelectAll()
{
	SetSel(0, -1);
}


void CRichEditCtrlEx::OnEditClearAll()
{
	SetSel(0, -1);
	Clear();
}

BOOL CRichEditCtrlEx::GetEditStatusEnable()
{
	CHARRANGE charRange;

	GetSel(charRange);
	if(charRange.cpMin == charRange.cpMax)
	{
		return FALSE;
	}

	return TRUE;
}
